﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data.SqlClient;
using System.Data;

namespace SampleDropDownList
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        SqlConnection connection;
        SqlCommand cmd;
        public MainWindow()
        {
            InitializeComponent();

            connection = new SqlConnection("Data Source=DESKTOP-722E8K8\\SQLEXPRESS;Initial Catalog=Sample;Integrated Security=True");
            connection.Open();
            dataGridBinding();
        }

        public void dataGridBinding()
        {
            //SfDataGrid Binding
            SqlDataAdapter myDataAdapter = new SqlDataAdapter("SELECT * FROM Purchases", connection);
            DataSet myDataset = new DataSet();
            myDataAdapter.Fill(myDataset);
            purchasesDataGrid.ItemsSource = myDataset.Tables[0].DefaultView;

            //gridDropDownList Binding
            SqlDataAdapter myDataAdapter1 = new SqlDataAdapter("SELECT * FROM Products",connection);
            DataSet myDataset1 = new DataSet();
            myDataAdapter1.Fill(myDataset1);
            dropDownList.ItemsSource = myDataset1.Tables[0].DefaultView;

            // 1 - When you choose from the drop down list an element and you validate it shows a blanck in the new line
            // 2 - When you try to double click to update a row in " BarCode" column the program crashes because of a null exception value cannot be null
        }

        private void purchasesDataGrid_RowValidated(object sender, Syncfusion.UI.Xaml.Grid.RowValidatedEventArgs e)
        {
            SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Purchases",connection);

            try
            {
                if (e.RowIndex == 1)
                {
                    cmd = new SqlCommand("INSERT INTO Purchases (Barcode,Qnt,Price) VALUES (@Barcode,@Qnt,@Price)", connection);
                    cmd.Parameters.Add("@BarCode", SqlDbType.VarChar, 50, "BarCode");
                    cmd.Parameters.Add("@Qnt", SqlDbType.Int, 4, "Qnt");
                    cmd.Parameters.Add("@Price", SqlDbType.Money, 9, "Price");
                    da.InsertCommand = cmd;
                    DataSet ds = new DataSet();
                    da.Fill(ds);
                    DataRow dr = ds.Tables[0].NewRow();
                    dr["BarCode"] = (e.RowData as DataRowView).Row.ItemArray[1];
                    dr["Qnt"] = (e.RowData as DataRowView).Row.ItemArray[2];
                    dr["Price"] = (e.RowData as DataRowView).Row.ItemArray[3];
                    ds.Tables[0].Rows.Add(dr);
                    da.Update(ds);
                }
                else
                {
                    if (e.RowIndex > 1)
                    {
                        da.UpdateCommand = new SqlCommand("UPDATE Purchases Set Barcode=@BarCode, Qnt=@Qnt, Price=@Price WHERE ID=@ID", connection);
                        da.UpdateCommand.Parameters.Add("@BarCode", SqlDbType.VarChar, 50, "BarCode");
                        da.UpdateCommand.Parameters.Add("@Qnt", SqlDbType.Int, 4, "Qnt");
                        da.UpdateCommand.Parameters.Add("@Price", SqlDbType.Money, 9, "Price");
                        SqlParameter parameter = da.UpdateCommand.Parameters.Add("@ID", SqlDbType.Int, 4);
                        parameter.SourceColumn = "ID";
                        parameter.SourceVersion = DataRowVersion.Original;
                        DataTable dt = new DataTable();
                        dt.Clear();
                        da.Fill(dt);
                        DataRow dr = dt.Rows[e.RowIndex - 2];
                        dr["BarCode"] = (e.RowData as DataRowView).Row.ItemArray[1];
                        dr["Qnt"] = (e.RowData as DataRowView).Row.ItemArray[2];
                        dr["Price"] = (e.RowData as DataRowView).Row.ItemArray[3];
                        da.Update(dt);
                    }
                }
                dataGridBinding();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error:\n" + ex.ToString());
                dataGridBinding();
            }


        }
    }
}
